3 # Author: Alan J. Pippin (apippin@pippins.net)
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
18 # Package Dependencies (apt-get install these for example):
19 # lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
21 # Specific Executable (program) Dependencies (must be found in $PATH):
22 # volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs
24 # Optional Dependencies:
25 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
28 ##############################################################################
29 # Local Machine Settings:
30 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
31 # and the local conf file created by each local machine (rip_dvd.conf)
32 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
33 # This will allow you to override all the default values to meet your needs
34 # in a way that won't get clobbered when you pull updates from my GIT repo.
35 ##############################################################################
36 config="${0%/*}/rip_dvd.conf"
37 [ -e "${config}.dist" ] && . ${config}.dist
38 [ -e "${config}" ] && . ${config}
40 ##############################################################################################
41 # Command line processing
42 ##############################################################################################
52 typeset profile="xvidvhq"
54 typeset -i keep_isofile=0
55 typeset -i keep_vobfile=0
56 typeset -i keep_dvdfolder=0
57 typeset -i keep_intermediate_files=0
58 typeset -i make_final_dest_vob=0
59 typeset -i make_final_dest_iso=0
60 typeset -i make_final_dest_folder=0
61 typeset -i make_final_dest_comp=0
63 typeset -i show_usage=0
64 typeset -i mirror_mode=0
65 typeset -i target_bitrate=0
66 typeset -i target_size=0
67 typeset -i audio_2ch=0
68 typeset -i invalid_feature_title=0
69 typeset -i feature_title_override=0
70 typeset -i mplayer_dumpstream_incompatibility=0
72 while (($#)) && getopts 2mvifkxht:n:d:b:s:t:a:p:e: opt "$@"
77 (b) target_bitrate=$OPTARG;;
78 (s) target_size=$OPTARG;;
80 (v) make_final_dest_vob=1;;
81 (i) make_final_dest_iso=1;;
82 (f) make_final_dest_folder=1;;
83 (x) make_final_dest_comp=1;;
85 (k) keep_intermediate_files=1;;
86 (t) feature_title_override=$OPTARG;;
89 (e) extension=$OPTARG;;
92 (:) echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
93 (\?) echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
100 echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
101 echo >&2 "Revision $REV"
103 echo >&2 " -d <destdir> Specify the destination directory to store the ripped DVD to"
104 echo >&2 " -n <dvdname> Specify a path to a DVD folder or file to process:"
105 echo >&2 " 1) If this option is not specified, the DVD will be ripped from $dev"
106 echo >&2 " 2) If dvdname exists in $tmpdir, it will be ripped as a DVD instead of $dev"
107 echo >&2 " 3) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
108 echo >&2 " 4) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
109 echo >&2 " 5) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
110 echo >&2 " -p <profile> Specify which encoding profile to use in -x mode as shown below:"
111 echo >&2 " - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding (default)"
112 echo >&2 " - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding"
113 echo >&2 " - xvid = AVI, fast encoding, Xvid codec, 2 pass encoding"
114 echo >&2 " - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
115 echo >&2 " - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
116 echo >&2 " - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
117 echo >&2 " - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
118 echo >&2 " - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
119 echo >&2 " -e <ext> Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
120 echo >&2 " If you run multiple instances of this script ripping the same DVD, you need to specify this option."
121 echo >&2 " -m Make a mirror image of the DVD and save it as a DVD ISO file"
122 echo >&2 " The default operation is non-mirror mode where only the main"
123 echo >&2 " feature title will be ripped."
124 echo >&2 " -v Make the final image a DVD VOB file"
125 echo >&2 " -i Make the final image a DVD ISO file"
126 echo >&2 " -f Make the final image a DVD folder"
127 echo >&2 " -x Make the final image a compressed file based on your profile selection"
128 echo >&2 " You must also specify the target size or bitrate using the '-s' or '-b' options"
129 echo >&2 " -s <size> Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
130 echo >&2 " -b <bitrate> Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"
131 echo >&2 " -a <W:H> Specify the width x height aspect ratio to scale the DVD to (only used in -x mode)"
132 echo >&2 " <W> If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
133 echo >&2 " The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
134 echo >&2 " -2 Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
135 echo >&2 " -k Keep the intermediate files (good for debugging)"
136 echo >&2 " In -x mode, run with this option to keep the original .VOB file"
137 echo >&2 " By default, all intermediary files are deleted. Only the final image is kept"
138 echo >&2 " -t <title> Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
139 echo >&2 " -w Set the sh Execute/Verbose flag (causes every command to be echoed)"
144 if (($errors)) || (($show_usage))
149 # Sanity Check - Command Line Options
150 if [ "$dest" == "" ]; then
151 echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
155 if ([ $target_bitrate -ne 0 ] || [ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
156 echo "-E- You can't specify a bitrate, target_size, or aspect in non compressed file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
160 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
161 echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
165 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] &&
166 [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
167 echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-x'" | tee -a $logfile
171 if [ $mirror_mode -eq 1 ]; then
172 if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] ||
173 [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
174 echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
179 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
180 if [ "$aspect" != "" ]; then
181 echo "$aspect" | grep -q "x"
183 echo "-E- You must specify the aspect option with a value whose format is W:H"
186 echo "$aspect" | grep -q ":"
188 SCALE=",scale -zoom -sws 9 -xy $aspect"
190 SCALE=",scale=$aspect"
195 # Sanity Check - Key executables
196 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
197 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
198 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
199 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
200 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
201 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
202 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
203 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
205 ##############################################################################################
208 if [ -z "$dvdname" ]; then
209 # make sure the DVD device is accessible
210 volname $dev > /dev/null 2>&1
212 echo "-E- Can't access the DVD device $dev"
215 # now capture the volume name from the device
216 dvdname=`volname $dev | awk '{ print $1 }'`
219 # check to see if dvdname is a full path to a real directory
220 # if it is, set dvdname and dvdpath appropriately
221 if [ -d "$dvdname" ]; then
223 dvdname=`basename "$dvdname"`
225 if [ -z "$dvdname" ]; then
226 echo "-E- Unable to extract dvdname from path: $dvdpath"
229 if [ ! -d "$dvdpath/VIDEO_TS" ]; then
230 echo "-E- You must supply a full path to a valid DVD folder with this option"
235 # Check to see if dvdname is a full path to a file
236 if [ -f "$dvdname" ]; then
239 # check to see if dvdname is a full path to an MPG2 (VOB) file
240 # if it is, set dvdname and vobfile appropriately
241 file "$dvdname" | grep -q "MPEG"
243 # It is a valid MPEG2 file, now strip the extension off our dvdname
245 dvdname=`basename "$dvdname"`
246 dvdname=${dvdname%.[^.]*}
251 # check to see if dvdname is a full path to an ISO file
252 # if it is, set dvdname and isofile appropriately
253 file "$dvdname" | grep -q "ISO"
255 # It is a valid ISO file, now strip the extension off our dvdname
257 dvdname=`basename "$dvdname"`
258 dvdname=${dvdname%.[^.]*}
263 # If we didn't find a handler for the file above, complain
264 if [ $valid_file -eq 0 ]; then
265 echo "-E- Unsupported file type: $vobfile"
272 # remove bad characters from the dvdname
273 dvdname=${dvdname%.} # remove trailing '.' character
275 # add the suffix extension to the end of the dvdname
276 dvdname=$dvdname$extension
278 # make a "safe" dvdname (remove special characters)
279 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
281 # Make sure we have a non-empty dvdname
282 if [ -z "$dvdname" ]; then
283 echo "-E- unable to determine dvdname"
287 # make sure our vobfile value is set
288 if [ -z "$vobfile" ]; then
289 vobfile="$dest/$dvdname.VOB"
292 # set up some variables to hold various logfiles
293 logfile="$logdir/$dvdname.log"
294 passlogfile="$tmpdir/$safedvdname.log"
295 ddrescuelog=`tempfile`
296 dvdauthorlog=`tempfile`
300 # create the tmpdir if it doesn't already exist
301 if [ ! -d "$tmpdir" ]; then
304 echo "-E- Unable to create the tmpdir: $tmpdir"
309 # create the logdir if it doesn't already exist
310 if [ ! -d "$logdir" ]; then
313 echo "-E- Unable to create the logdir: $logdir"
318 ##############################################################################################
320 ##############################################################################################
322 if [ $keep_intermediate_files -eq 0 ]; then
323 [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
324 [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
325 [[ -e "$encodelog" ]] && rm -f "$encodelog"
326 [[ -e "$dumplog" ]] && rm -f "$dumplog"
328 [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
329 [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
330 [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
331 [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
337 if [[ -z "$1" ]]; then
338 msg="-E- control-c killed us"
342 echo -e 2>&1 "$msg" | tee -a "$logfile"
343 if [[ -n "$mailto" ]]; then
344 echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
349 # Call our cleanup functions on INT and EXIT signals
350 trap fatal_and_exit INT
353 ##############################################################################################
354 # processing functions
355 ##############################################################################################
357 # encode the vob file into a compressed file format
358 function encode_vob_file {
359 typeset -i found_profile=0
362 if [ "$profile" == "xvid" ] || [ "$profile" == "xvidhq" ] || [ "$profile" == "xvidvhq" ]; then
364 final_output_file="$dest/$dvdname.avi"
365 mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
366 mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
367 mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
368 mencoder_video_encoder_opts="-ovc xvid -xvidencopts pass=%PASS"
370 # Very High Quality (16fps)
371 if [ "$profile" == "xvidvhq" ]; then
372 video_encoder_opts[0]="bitrate=$target_bitrate"
373 video_encoder_opts[1]="threads=$mencoder_threads"
374 video_encoder_opts[2]="chroma_opt"
375 video_encoder_opts[3]="vhq=4"
376 video_encoder_opts[4]="bvhq=1"
377 video_encoder_opts[5]="quant_type=mpeg"
378 video_encoder_opts[6]="autoaspect"
380 # High Quality (20fps)
381 if [ "$profile" == "xvidhq" ]; then
382 video_encoder_opts[0]="bitrate=$target_bitrate"
383 video_encoder_opts[1]="threads=$mencoder_threads"
384 video_encoder_opts[2]="chroma_opt"
385 video_encoder_opts[3]="vhq=2"
386 video_encoder_opts[4]="bvhq=1"
387 video_encoder_opts[5]="quant_type=mpeg"
388 video_encoder_opts[6]="autoaspect"
391 if [ "$profile" == "xvid" ]; then
392 video_encoder_opts[0]="bitrate=$target_bitrate"
393 video_encoder_opts[1]="threads=$mencoder_threads"
394 video_encoder_opts[2]="vhq=0"
395 video_encoder_opts[3]="turbo"
396 video_encoder_opts[4]="autoaspect"
399 for OPTS in "${video_encoder_opts[@]}"; do
400 mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
403 if [ $audio_2ch -eq 0 ]; then
404 # These options produce good 6 channel audio for linux and windows
405 mencoder_audio_opts="-oac copy"
406 # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
407 mencoder_audioch_opts[0]="-channels 6 -af channels=6"
408 mencoder_audioch_opts[1]="-af channels=6"
409 mencoder_audioch_opts[2]=""
411 # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
412 mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
413 mencoder_audioch_opts[0]=""
418 # MP4 encoding profiles
419 if [ "$profile" == "mp4" ] || [ "$profile" == "mp4hq" ] || [ "$profile" == "mp4vhq" ]; then
421 final_output_file="$dest/$dvdname.mp4"
422 mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
423 mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
424 mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
425 mencoder_video_encoder_opts="-ovc x264 -x264encopts pass=%PASS"
427 # Very High Quality (6fps)
428 if [ "$profile" == "mp4vhq" ]; then
429 video_encoder_opts[0]="bitrate=$target_bitrate"
430 video_encoder_opts[1]="threads=$mencoder_threads"
431 video_encoder_opts[2]="subq=6"
432 video_encoder_opts[3]="frameref=5"
433 video_encoder_opts[4]="bframes=3"
434 video_encoder_opts[5]="8x8dct"
435 video_encoder_opts[6]="me=umh"
436 video_encoder_opts[7]="b_pyramid"
437 video_encoder_opts[8]="weight_b"
438 video_encoder_opts[9]="partitions=all"
440 # High Quality (13fps)
441 if [ "$profile" == "mp4hq" ]; then
442 video_encoder_opts[0]="bitrate=$target_bitrate"
443 video_encoder_opts[1]="threads=$mencoder_threads"
444 video_encoder_opts[2]="subq=5"
445 video_encoder_opts[3]="frameref=2"
446 video_encoder_opts[4]="bframes=3"
447 video_encoder_opts[5]="8x8dct"
448 video_encoder_opts[6]="b_pyramid"
449 video_encoder_opts[7]="weight_b"
452 if [ "$profile" == "mp4" ]; then
453 video_encoder_opts[0]="bitrate=$target_bitrate"
454 video_encoder_opts[1]="threads=$mencoder_threads"
455 video_encoder_opts[2]="subq=4"
456 video_encoder_opts[3]="bframes=2"
457 video_encoder_opts[4]="b_pyramid"
458 video_encoder_opts[5]="weight_b"
461 for OPTS in "${video_encoder_opts[@]}"; do
462 mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
465 if [ $audio_2ch -eq 0 ]; then
466 # These options produce good 6 channel audio for linux and windows
467 #mencoder_audio_opts="-oac copy"
468 # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
469 #mencoder_audioch_opts[0]="-channels 6 -af channels=6"
470 #mencoder_audioch_opts[1]="-af channels=6"
471 #mencoder_audioch_opts[2]=""
472 mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
473 mencoder_audioch_opts[0]="-channels 6 -srate 48000"
475 # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
476 #mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
477 #mencoder_audioch_opts[0]=""
478 mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
479 mencoder_audioch_opts[0]="-channels 2 -srate 48000"
484 # iphone and ipod MP4 profiles
485 if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
487 if [ "$profile" == "iphone" ]; then
489 # scale width to 480, set height appropriately, but keep a multiple of 16
490 #SCALE=",scale=480:-10"
491 # scale the video down however far is necessary to fit in 480x320
492 SCALE=",dsize=480:320:0,scale=-8:-8"
495 # scale width to 320, set height appropriately, but keep a multiple of 16
496 #SCALE=",scale=320:-10"
497 # scale the video down however far is necessary to fit in 320x240
498 SCALE=",dsize=320:240:0,scale=-8:-8"
500 final_output_file="$dest/$dvdname.mp4"
501 mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
502 mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
503 mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
504 mencoder_video_encoder_opts="-ovc x264 -x264encopts pass=%PASS"
505 video_encoder_opts[0]="bitrate=$target_bitrate"
506 video_encoder_opts[1]="threads=$mencoder_threads"
507 video_encoder_opts[2]="vbv_maxrate=1500"
508 video_encoder_opts[3]="vbv_bufsize=2000"
509 video_encoder_opts[4]="nocabac"
510 video_encoder_opts[5]="me=umh"
511 video_encoder_opts[6]="subq=6"
512 video_encoder_opts[7]="frameref=6"
513 video_encoder_opts[8]="trellis=1"
514 video_encoder_opts[9]="level_idc=30"
515 video_encoder_opts[10]="global_header"
516 video_encoder_opts[11]="bframes=0"
517 video_encoder_opts[12]="partitions=all"
518 for OPTS in "${video_encoder_opts[@]}"; do
519 mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
522 mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
523 mencoder_audioch_opts[0]="-channels 2 -srate 48000"
526 if [ $found_profile -eq 0 ]; then
527 fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
530 # Do not edit this line. $mencoder_video_encoder_opts must be last
531 mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
536 # Set some options based on which pass we are in
537 mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
538 [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
539 [ $PASS -eq 1 ] && output_file="/dev/null"
540 [ $PASS -eq 2 ] && output_file="$final_output_file"
542 # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
543 for CH_OPTS in "${mencoder_audioch_opts[@]}";
545 echo -e " Encoding pass $PASS"
546 echo -e "\n Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
547 mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
549 grep -q "\[channels\] Invalid" $encodelog
553 echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
557 if [ $mencoder_retval != 0 ]; then
558 fatal_and_exit "-E- Unhandled mencoder error"
561 # Concatenate the encode log to our main log file, greping out unwanted lines
562 cat $encodelog | grep -v "Pos:" >> "$logfile"
567 function make_dvd_iso_image {
571 # check to see if we have a dvdpath to rip from instead of $dev
572 if [ -z "$dvdpath" ]; then
573 # load the CSS codes in the DVD drive
574 lsdvd $dev >> "$logfile"
576 fatal_and_exit "-E- lsdvd $dev failed"
579 # read the DVD, ignoring/skipping CRC errors
580 ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
582 fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
584 cat "$ddrescuelog" >> "$logfile"
586 # rip from a path instead
587 make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
591 function make_dvd_iso_image_from_folder {
597 echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
599 # make an iso image out of our directory
600 echo " mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
601 mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
603 # set the audio languages from the iso if it exists and is non-zero in size
604 if [ -s "$dst" ]; then
605 get_feature_title "$dst"
606 get_audio_id_from_iso "$dst"
609 # make sure we were able to create the iso image from the folder given to us
610 if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
611 echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
612 echo " Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
613 # remove the bad iso file
614 [[ -e "$dst" ]] && rm -f "$dst"
615 # get the feature title from the DVD folder
616 get_feature_title "$dvdpath"
617 # create our main VOB file from the ISO
618 create_main_vob_with_mplayer "$dvdpath"
619 # get our audio id from the VOB file
620 get_audio_id_from_vob "$vobfile"
624 function make_dvdbackup_folder_image {
625 # extract the feature title from the DVD image
626 echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
627 [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
628 dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
630 fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
634 function make_dvdauthor_folder_image {
635 # create a new DVD video of the feature title
636 echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
637 [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
638 dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
639 cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
641 # There is a chance that dvdauthor won't like some of the VOBs.
642 # We can't tell ahead of time which ones it will choke on.
643 # So, we need to run it over and over again until it can process
644 # all the VOBs. If it can't handle one of them, run it through
645 # mencoder to fix it and try again. These errors are typically
646 # present due to the copy protection that ddrescue removed.
647 grep -q "SCR moves" $dvdauthorlog
648 while [ $? == 0 ]; do
649 # fix bad vobs that get the "SCR moves backwards" error:
650 # STAT: Processing VTS_01_0.VOB...
651 # ERR: SCR moves backwards, remultiplex input.
652 badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
653 if [[ ! -f "$badvob" ]]; then
654 fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
656 echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
657 cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
658 mv -f $badvob.fixed $badvob
659 echo "-> Creating DVD video $dest/$dvdname"
660 dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
661 cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
662 grep -q "SCR moves" $dvdauthorlog
666 function get_feature_title {
668 # if a feature title was given on the command line, use it
669 if [ $feature_title_override -ne 0 ]; then
670 feature_title=$feature_title_override
673 # otherwise, use lsdvd to figure it out
674 if [ $ripdvd -eq 1 ]; then
675 feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
677 feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
681 function create_main_vob_with_cat {
682 # cd to the feature title DVD folder
683 pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
685 fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
688 # concatenate all the VOBs together into 1 giant VOB
689 vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
690 cat $vobs > "$tmpdir/$dvdname.VOB"
692 # cd back to the dir we started from
693 popd > /dev/null 2>&1
696 function create_main_vob_with_mplayer {
698 # argument processing
702 # make sure we have a valid feature title
703 if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
704 fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
707 # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
708 if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
709 msg="-E- We detected an mplayer dumpstream incompatibility earlier."
710 msg="$msg We also detected another condition that requires us to use dumpstream. "
711 msg="$msg\n Unable to rip this DVD in the mode you requested."
712 fatal_and_exit "$msg"
715 # use mplayer to create the main VOB file
716 echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
717 echo " mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
718 mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
720 cat $dumplog | grep -v "^A:" >> "$logfile"
721 fatal_and_exit "-E- Mplayer Failed"
723 cat $dumplog | grep -v "^A:" >> "$logfile"
724 [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
727 function get_audio_id_from_iso {
728 # Adjust our audio ID to find the english audio stream
729 # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
733 mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
734 grep -q "aid: $aid" $aidcheck
735 while [ $? == 1 ] && [ $aid -lt 159 ]; do
737 grep -q "aid: $aid" $aidcheck
739 [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
740 echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
741 # mencoder default DVD audio track language selection (english)
742 lang_opts="-aid $aid -alang en"
745 function get_crop_from_iso {
747 echo "-> Detecting black frame border crop value from ISO file"
748 echo " mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
749 mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
750 [[ -e "md5sums" ]] && rm -f "md5sums"
751 CROP=`cat $dumplog | grep CROP | tail -1`
752 echo " Found crop value of $CROP" >> "$logfile"
756 CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
757 echo " Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
758 if [ -z "$CROP" ]; then
759 fatal_and_exit "-E- Unable to extract CROP value from iso: $isofile"
761 if [ $CROPCHECK -lt 0 ]; then
766 echo " Setting mencoder crop filter to: $CROP"
769 function get_crop_from_vob {
771 echo "-> Detecting black frame border crop value from VOB file"
772 echo " mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark \"$vobfile\" > $dumplog 2>&1" >> "$logfile"
773 mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark "$vobfile" > $dumplog 2>&1
774 [[ -e "md5sums" ]] && rm -f "md5sums"
775 CROP=`cat $dumplog | grep CROP | tail -1`
776 echo " Found crop value of $CROP" >> "$logfile"
780 CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
781 echo " Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
782 if [ -z "$CROP" ]; then
783 fatal_and_exit "-E- Unable to extract CROP value from iso: $isofile"
785 if [ $CROPCHECK -lt 0 ]; then
790 echo " Setting mencoder crop filter to: $CROP"
793 function get_audio_id_from_vob {
794 # Adjust our audio ID to find the english audio stream
795 # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
799 mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
800 grep -q "Found audio stream: $aid" $aidcheck
801 while [ $? == 1 ] && [ $aid -lt 159 ]; do
803 grep -q "Found audio stream: $aid" $aidcheck
805 [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
806 echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
807 # mencoder default DVD audio track language selection (english)
808 lang_opts="-aid $aid -alang en"
811 function check_vob_for_corrupted_start {
812 # check to see if the beginning of the DVD has a form of copy protection
813 # where they have deliberately broken the first X number of frames of the DVD.
814 # If we don't skip these, our resulting VOB file will not play.
815 badvobcheck=`tempfile`
818 mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
820 fatal_and_exit "-E- Mencoder Failed"
822 grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
823 while [ $? == 0 ] && [ $skip -lt $endpos ]; do
824 (( skip = skip + 5 ))
825 echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
826 mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
828 fatal_and_exit "-E- Mencoder Failed"
830 grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
832 [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
834 # cat the giant VOB into mencoder to create a playable VOB file
835 cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
837 fatal_and_exit "-E- Mencoder Failed"
841 function check_vob_for_completeness {
842 # check to make sure we got out a complete VOB.
843 # there is another kind of copy protection where the VOB's may
844 # have "MPG EOF" frames in the middle of the stream.
845 # this causes mencoder to not process the entire VOB, and exit without any errors.
846 # detect this by seeing how much smaller the dst vob is from the src vob.
847 MAX_FILESIZE_DELTA_PERCENT=70
848 SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
849 DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
850 FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
851 if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
852 # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
853 echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
854 create_main_vob_with_mplayer "$isofile"
855 [[ -e "$dumplog" ]] && rm -f $dumplog
856 DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
857 FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
858 if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
859 fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n I recommend using another ripping mode like '-m' or '-i'"
864 function check_vob_for_too_many_video_packets {
865 # If our earlier algorithm to work around this failed, throw an error.
866 # check to see if this DVD has a protection scheme we don't know how to work around
867 # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
868 # for some reason, the video is black, while the audio rolls, then the video finally comes
869 # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of
870 # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
871 # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
872 grep -q "Too many video packets in the buffer:" "$logfile"
874 # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
875 echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
876 create_main_vob_with_mplayer "$isofile"
877 grep -q "Too many video packets in the buffer:" $dumplog
879 [[ -e "$dumplog" ]] && rm -f $dumplog
880 fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n I recommend using another ripping mode like '-m' or '-i'"
882 [[ -e "$dumplog" ]] && rm -f $dumplog
886 function check_vob_for_a52_crc_errors {
887 # Let's see if we can playback our newly created VOB file without any errors.
888 # if there are issues, let's detect them now, and try to recreate the VOB
889 # there are some forms of copy protection that have missed above, that evidence
890 # themselves when we try to playback the VOB file. This was added to deal with
891 # the "a52: CRC check failed" copy protection scheme.
894 echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
895 mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
896 cat $dumplog | grep -v "^A:" >> "$logfile"
897 errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
898 if [ $errors -gt $MAX_ERRORS ]; then
899 echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
900 create_main_vob_with_mplayer "$isofile"
901 echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
902 mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
904 cat $dumplog | grep -v "^A:" >> "$logfile"
905 fatal_and_exit "-E- Mplayer Failed"
907 cat $dumplog | grep -v "^A:" >> "$logfile"
908 errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
909 if [ $errors -gt $MAX_ERRORS ]; then
910 fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n I recommend using another ripping mode like '-m' or '-i'"
913 [[ -e "$dumplog" ]] && rm -f $dumplog
916 function calculate_bitrate_from_target_size {
917 # determine what our bitrate needs to be if a target size was specified instead
918 if [ $target_size -ne 0 ]; then
919 vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
920 ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
921 echo " With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
925 function create_dvdauthor_dvd_xml_file {
926 # make a dvdauthor xml menu file to create a valid DVD video from
927 # this script does a good job, but we'll still need to clean it up a bit after it runs
928 echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
929 makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
931 fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
934 # replace the first line of the xml file to remove the bad dest path
935 awk -v line=1 -v new_content="<dvdauthor>" '{
941 }' dvd.xml > dvd.xml.new
942 mv -f dvd.xml.new dvd.xml
944 fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
947 # remove the "<video " property line from the xml file
948 cat dvd.xml | grep -v "<video" > dvd.xml.new
949 mv -f dvd.xml.new dvd.xml
951 fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
954 # remove the extra <pgc>..</pgc> pairs
955 cat dvd.xml | awk 'BEGIN {x=1}
957 if ($0~"</pgc>") {x=0}
959 if ($0~"<pgc>") {x=1}
961 echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
962 mv -f dvd.xml.new dvd.xml
964 fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
967 # remove the VTS_*_0.VOB file as this is just the main menu video clip
968 cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
969 mv -f dvd.xml.new dvd.xml
971 fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
975 function check_for_mplayer_dumpstream_incompatibility {
977 echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
979 if [ ! -e "$vobfile" ]; then
980 # mplayer dumpstream does not work on DVDs that obscure the feature title.
981 # A DVD that has 99 titles, where the longest title isn't the main feature
982 # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
983 # out what the feature title is. This script will run through that flow if we
984 # set use_mplayer_dumpstream to 0. Check for this here.
985 if [ $ripdvd -eq 1 ]; then
986 lsdvd $dev | grep -q "Title: 99"
988 lsdvd "$isofile" | grep -q "Title: 99"
990 # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
991 if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
992 if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
993 echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
994 echo " You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
995 echo " You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
996 invalid_feature_title=1
998 echo " Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
999 echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
1000 echo " You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1001 use_mplayer_dumpstream=0
1002 invalid_feature_title=1
1008 # There is another form of protection that causes the mplayer dumpstream to fail.
1009 # This can be detected by telling mplayer to parse the VOB file by copying its audio
1010 # video streams to a dummy output file (/dev/null). Do that here to check for that
1011 # problem before continuing.
1012 if [ -e "$vobfile" ]; then
1013 mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
1014 mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
1015 grep -q "Too many audio packets in the buffer" $dumplog
1016 if [ $? == 0 ]; then
1017 echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
1018 use_mplayer_dumpstream=0
1019 mplayer_dumpstream_incompatibility=1
1021 [[ -e "$dumplog" ]] && rm -f $dumplog
1025 function fill_mythvideo_metadata {
1027 # This function must be passed the filename as an argument
1028 # The filename must be a full path to the file
1031 # Make sure the fill mythvideo metadata option has been set to 1
1032 if [ $fill_mythvideo_metadata -eq 0 ]; then
1033 echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
1037 # If the fill mythvideo metadata script is present, run it
1038 # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
1039 if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
1040 echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
1041 fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
1043 echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
1044 echo " Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
1048 # remove the intermediate VOB file
1049 function remove_intermediate_vob_file {
1050 if [ $keep_intermediate_files -eq 0 ]; then
1051 [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
1053 echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
1057 # remove the original DVD image
1058 function remove_intermediate_iso_file {
1059 [[ $keep_isofile -eq 1 ]] && return 1
1060 if [ $keep_intermediate_files -eq 0 ]; then
1061 [[ -e "$isofile" ]] && rm "$isofile"
1063 echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
1067 # remove the intermediate dvdbackup folder
1068 function remove_intermediate_dvdbackup_folder {
1069 if [ $keep_intermediate_files -eq 0 ]; then
1070 [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
1072 echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
1076 ##############################################################################################
1078 ##############################################################################################
1080 # Make a note of when this DVD rip started
1082 echo -e "\n$date DVD rip started" >> "$logfile"
1084 # Rip the DVD - Mirror Mode
1085 if [ $mirror_mode -eq 1 ]; then
1086 echo "-> Ripping DVD $dvdname to $dest"
1088 # use ddrescue to make an ISO image of the disk
1089 make_dvd_iso_image "$dest/$dvdname.iso"
1091 # add this video data to the mythtv DB
1092 fill_mythvideo_metadata "$dest/$dvdname.iso"
1094 # eject the disk upon completion
1098 echo "$date DVD rip completed" | tee -a "$logfile"
1100 if [[ -n "$mailto" ]]; then
1101 cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1106 # Rip the DVD - Main Title Feature Only
1107 if [ $mirror_mode -eq 0 ]; then
1109 # Rip image from DVD
1110 if [ $ripdvd -eq 1 ]; then
1111 echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
1112 # use ddrescue to make an ISO image of the disk
1113 make_dvd_iso_image "$tmpdir/$dvdname.iso"
1116 # Rip image from DVD path
1117 if [ -n "$dvdpath" ]; then
1118 echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
1119 make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
1122 # make sure our isofile value is set
1123 if [ -z "$isofile" ]; then
1124 isofile="$tmpdir/$dvdname.iso"
1127 if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
1129 if [ ! -e "$vobfile" ]; then
1130 echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
1132 # get the feature title from the ISO
1133 get_feature_title "$isofile"
1135 # get the crop value from the ISO
1138 # check for mplayer dumpstream incompatibilities
1139 # if they exist, this method will set this mode to 0.
1140 check_for_mplayer_dumpstream_incompatibility
1142 if [ $use_mplayer_dumpstream -eq 1 ]; then
1144 # get our audio id from the ISO file
1145 get_audio_id_from_iso "$isofile"
1147 # create our main VOB file from the ISO
1148 create_main_vob_with_mplayer "$isofile"
1150 # remove the intermediate VOB file
1151 remove_intermediate_vob_file
1153 # it's possible that our VOB is still corrupted in some manner
1154 # check to make sure it is still a good VOB before continuing.
1155 check_for_mplayer_dumpstream_incompatibility
1159 if [ $use_mplayer_dumpstream -eq 0 ]; then
1161 # use dvdbackup to make a DVD folder of the feature title
1162 make_dvdbackup_folder_image
1164 # create our main VOB file
1165 create_main_vob_with_cat
1167 # get our audio id from the VOB file
1168 get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
1170 # check for corrupted VOB start
1171 check_vob_for_corrupted_start
1173 # check to make sure our VOB is complete
1174 check_vob_for_completeness
1176 # check to make sure our VOB doesn't have too many video packets
1177 check_vob_for_too_many_video_packets
1179 # check to make sure our VOB doesn't have a52 crc errors
1180 check_vob_for_a52_crc_errors
1182 # remove the intermediate VOB file
1183 remove_intermediate_vob_file
1187 # remove the intermediate ISO file
1188 remove_intermediate_iso_file
1191 echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
1192 # get our audio id from the VOB file
1193 get_audio_id_from_vob "$vobfile"
1194 # get the crop value from the VOB
1198 # encode the VOB file to a compressed file format
1199 if [ $make_final_dest_comp -eq 1 ]; then
1200 echo "-> Encoding the DVD video to a compressed file" | tee -a "$logfile"
1202 # determine what our bitrate needs to be if a target size was specified instead
1203 calculate_bitrate_from_target_size
1205 # encode the vob file into a compressed file format
1208 if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
1209 [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
1210 [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
1212 echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
1213 echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1217 # add this video data to the mythtv DB
1218 [ $make_final_dest_comp -eq 1 ] && fill_mythvideo_metadata "$final_output_file"
1219 [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile"
1223 # use dvdbackup to make a DVD folder of the feature title
1224 make_dvdbackup_folder_image
1226 # cd to the feature title DVD folder
1227 pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1228 if [ $? != 0 ]; then
1229 fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1232 # create the dvd.xml file for dvdauthor
1233 create_dvdauthor_dvd_xml_file
1235 # make the final DVD folder image
1236 make_dvdauthor_folder_image
1238 # add this video data to the mythtv DB
1239 fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS"
1241 # cd back to the dir we started from
1242 popd > /dev/null 2>&1
1244 if [ $make_final_dest_iso -eq 1 ]; then
1246 # make an iso image out of our directory
1247 make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1249 # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory
1250 if [ -s "$dest/$dvdname.iso" ]; then
1251 if [ $make_final_dest_folder -eq 0 ]; then
1252 echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1253 # remove the folder of the DVD image now that we have a .iso version of it
1254 [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1257 # we created an empty iso file, remove it
1258 echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1259 echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1260 [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1263 # add this video data to the mythtv DB
1264 fill_mythvideo_metadata "$dest/$dvdname.iso"
1270 # remove the ddrescue DVD ISO image
1271 remove_intermediate_iso_file
1273 # remove the tmp dvdbackup folder of the DVD image
1274 remove_intermediate_dvdbackup_folder
1276 # eject the DVD disk upon completion
1277 [ $ripdvd -eq 1 ] && eject -T $dev
1280 echo "$date DVD rip completed" | tee -a "$logfile"
1282 if [[ -n "$mailto" ]]; then
1283 cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1288 ##############################################################################################